node{
    def sonarOrgKey = "cours-eftl-ggestin"
    def sonarProjectKey = "${sonarOrgKey}_IMEN-Petclinic"

    try  {

 stage('Checkout'){
        checkout scm
        def pom = readMavenPom file: 'pom.xml'
        if (pom){
            echo "Building version ${pom.version}"
        }
        sh "chmod +x ./mvnw"
    }
    stage("build"){
        sh "./mvnw package -DskipTests"
    }
    if ( !(env.SKIP_TESTS) ) {
        stage("tests unitaires") {
            sh "./mvnw test"
        }
    }
    stage("quality analysis"){
        def skipTests = ''
        if  ( env.SKIP_TESTS.toBoolean()){
            skipTests = '-DskipTests'
        }  
        sh "./mvnw verify org.sonarsource.scanner.maven:sonar-maven-plugin:sonar -Dsonar.projectKey=cours-eftl-ggestin_IMEN-Petclinic"

    }
    stage ("archive Artifacts") {
        archiveArtifacts '**/target/*.jar'
        if ( !(env.SKIP_TESTS.toBoolean())) {
            junit allowEmptyResults: true, keepLongStdio: true, skipMarkingBuildUnstable: true, skipPublishingChecks: true, testResults: '**/target/surefire-reports/*.xml'

        }

    }
    } catch (Exception error) {
        // Send mail, notification
        throw error 
        

    }

   
}
